Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.Designer.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.Designer.cs	(revision 845)
@@ -2131,7 +3556,11 @@
         private UpdateOrderOption _updateOrder;
         
+        private ResourceTableAdapter _resourceTableAdapter;
+        
         private ClientTableAdapter _clientTableAdapter;
         
-        private ResourceTableAdapter _resourceTableAdapter;
+        private HiveUserTableAdapter _hiveUserTableAdapter;
+        
+        private PermissionOwnerTableAdapter _permissionOwnerTableAdapter;
         
         private bool _backupDataSetBeforeUpdate;
@@ -2146,4 +3575,17 @@
             set {
                 this._updateOrder = value;
+            }
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.ComponentModel.EditorAttribute("Microsoft.VSDesigner.DataSource.Design.TableAdapterManagerPropertyEditor, Microso" +
+            "ft.VSDesigner, Version=8.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" +
+            "", "System.Drawing.Design.UITypeEditor")]
+        public ResourceTableAdapter ResourceTableAdapter {
+            get {
+                return this._resourceTableAdapter;
+            }
+            set {
+                this._resourceTableAdapter = value;
             }
         }
@@ -2166,10 +3608,23 @@
             "ft.VSDesigner, Version=8.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" +
             "", "System.Drawing.Design.UITypeEditor")]
-        public ResourceTableAdapter ResourceTableAdapter {
+        public HiveUserTableAdapter HiveUserTableAdapter {
             get {
-                return this._resourceTableAdapter;
+                return this._hiveUserTableAdapter;
             }
             set {
-                this._resourceTableAdapter = value;
+                this._hiveUserTableAdapter = value;
+            }
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.ComponentModel.EditorAttribute("Microsoft.VSDesigner.DataSource.Design.TableAdapterManagerPropertyEditor, Microso" +
+            "ft.VSDesigner, Version=8.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" +
+            "", "System.Drawing.Design.UITypeEditor")]
+        public PermissionOwnerTableAdapter PermissionOwnerTableAdapter {
+            get {
+                return this._permissionOwnerTableAdapter;
+            }
+            set {
+                this._permissionOwnerTableAdapter = value;
             }
         }
@@ -2192,11 +3647,19 @@
                     return this._connection;
                 }
+                if (((this._resourceTableAdapter != null) 
+                            && (this._resourceTableAdapter.Connection != null))) {
+                    return this._resourceTableAdapter.Connection;
+                }
                 if (((this._clientTableAdapter != null) 
                             && (this._clientTableAdapter.Connection != null))) {
                     return this._clientTableAdapter.Connection;
                 }
-                if (((this._resourceTableAdapter != null) 
-                            && (this._resourceTableAdapter.Connection != null))) {
-                    return this._resourceTableAdapter.Connection;
+                if (((this._hiveUserTableAdapter != null) 
+                            && (this._hiveUserTableAdapter.Connection != null))) {
+                    return this._hiveUserTableAdapter.Connection;
+                }
+                if (((this._permissionOwnerTableAdapter != null) 
+                            && (this._permissionOwnerTableAdapter.Connection != null))) {
+                    return this._permissionOwnerTableAdapter.Connection;
                 }
                 return null;
@@ -2212,8 +3675,14 @@
             get {
                 int count = 0;
+                if ((this._resourceTableAdapter != null)) {
+                    count = (count + 1);
+                }
                 if ((this._clientTableAdapter != null)) {
                     count = (count + 1);
                 }
-                if ((this._resourceTableAdapter != null)) {
+                if ((this._hiveUserTableAdapter != null)) {
+                    count = (count + 1);
+                }
+                if ((this._permissionOwnerTableAdapter != null)) {
                     count = (count + 1);
                 }
@@ -2228,4 +3697,13 @@
         private int UpdateUpdatedRows(dsHiveServer dataSet, global::System.Collections.Generic.List<global::System.Data.DataRow> allChangedRows, global::System.Collections.Generic.List<global::System.Data.DataRow> allAddedRows) {
             int result = 0;
+            if ((this._permissionOwnerTableAdapter != null)) {
+                global::System.Data.DataRow[] updatedRows = dataSet.PermissionOwner.Select(null, null, global::System.Data.DataViewRowState.ModifiedCurrent);
+                updatedRows = this.GetRealUpdatedRows(updatedRows, allAddedRows);
+                if (((updatedRows != null) 
+                            && (0 < updatedRows.Length))) {
+                    result = (result + this._permissionOwnerTableAdapter.Update(updatedRows));
+                    allChangedRows.AddRange(updatedRows);
+                }
+            }
             if ((this._resourceTableAdapter != null)) {
                 global::System.Data.DataRow[] updatedRows = dataSet.Resource.Select(null, null, global::System.Data.DataViewRowState.ModifiedCurrent);
@@ -2246,4 +3724,13 @@
                 }
             }
+            if ((this._hiveUserTableAdapter != null)) {
+                global::System.Data.DataRow[] updatedRows = dataSet.HiveUser.Select(null, null, global::System.Data.DataViewRowState.ModifiedCurrent);
+                updatedRows = this.GetRealUpdatedRows(updatedRows, allAddedRows);
+                if (((updatedRows != null) 
+                            && (0 < updatedRows.Length))) {
+                    result = (result + this._hiveUserTableAdapter.Update(updatedRows));
+                    allChangedRows.AddRange(updatedRows);
+                }
+            }
             return result;
         }
@@ -2255,4 +3742,12 @@
         private int UpdateInsertedRows(dsHiveServer dataSet, global::System.Collections.Generic.List<global::System.Data.DataRow> allAddedRows) {
             int result = 0;
+            if ((this._permissionOwnerTableAdapter != null)) {
+                global::System.Data.DataRow[] addedRows = dataSet.PermissionOwner.Select(null, null, global::System.Data.DataViewRowState.Added);
+                if (((addedRows != null) 
+                            && (0 < addedRows.Length))) {
+                    result = (result + this._permissionOwnerTableAdapter.Update(addedRows));
+                    allAddedRows.AddRange(addedRows);
+                }
+            }
             if ((this._resourceTableAdapter != null)) {
                 global::System.Data.DataRow[] addedRows = dataSet.Resource.Select(null, null, global::System.Data.DataViewRowState.Added);
@@ -2271,4 +3766,12 @@
                 }
             }
+            if ((this._hiveUserTableAdapter != null)) {
+                global::System.Data.DataRow[] addedRows = dataSet.HiveUser.Select(null, null, global::System.Data.DataViewRowState.Added);
+                if (((addedRows != null) 
+                            && (0 < addedRows.Length))) {
+                    result = (result + this._hiveUserTableAdapter.Update(addedRows));
+                    allAddedRows.AddRange(addedRows);
+                }
+            }
             return result;
         }
@@ -2280,4 +3783,12 @@
         private int UpdateDeletedRows(dsHiveServer dataSet, global::System.Collections.Generic.List<global::System.Data.DataRow> allChangedRows) {
             int result = 0;
+            if ((this._hiveUserTableAdapter != null)) {
+                global::System.Data.DataRow[] deletedRows = dataSet.HiveUser.Select(null, null, global::System.Data.DataViewRowState.Deleted);
+                if (((deletedRows != null) 
+                            && (0 < deletedRows.Length))) {
+                    result = (result + this._hiveUserTableAdapter.Update(deletedRows));
+                    allChangedRows.AddRange(deletedRows);
+                }
+            }
             if ((this._clientTableAdapter != null)) {
                 global::System.Data.DataRow[] deletedRows = dataSet.Client.Select(null, null, global::System.Data.DataViewRowState.Deleted);
@@ -2296,4 +3807,12 @@
                 }
             }
+            if ((this._permissionOwnerTableAdapter != null)) {
+                global::System.Data.DataRow[] deletedRows = dataSet.PermissionOwner.Select(null, null, global::System.Data.DataViewRowState.Deleted);
+                if (((deletedRows != null) 
+                            && (0 < deletedRows.Length))) {
+                    result = (result + this._permissionOwnerTableAdapter.Update(deletedRows));
+                    allChangedRows.AddRange(deletedRows);
+                }
+            }
             return result;
         }
@@ -2333,4 +3852,9 @@
                 return 0;
             }
+            if (((this._resourceTableAdapter != null) 
+                        && (this.MatchTableAdapterConnection(this._resourceTableAdapter.Connection) == false))) {
+                throw new global::System.ArgumentException("All TableAdapters managed by a TableAdapterManager must use the same connection s" +
+                        "tring.");
+            }
             if (((this._clientTableAdapter != null) 
                         && (this.MatchTableAdapterConnection(this._clientTableAdapter.Connection) == false))) {
@@ -2338,6 +3862,11 @@
                         "tring.");
             }
-            if (((this._resourceTableAdapter != null) 
-                        && (this.MatchTableAdapterConnection(this._resourceTableAdapter.Connection) == false))) {
+            if (((this._hiveUserTableAdapter != null) 
+                        && (this.MatchTableAdapterConnection(this._hiveUserTableAdapter.Connection) == false))) {
+                throw new global::System.ArgumentException("All TableAdapters managed by a TableAdapterManager must use the same connection s" +
+                        "tring.");
+            }
+            if (((this._permissionOwnerTableAdapter != null) 
+                        && (this.MatchTableAdapterConnection(this._permissionOwnerTableAdapter.Connection) == false))) {
                 throw new global::System.ArgumentException("All TableAdapters managed by a TableAdapterManager must use the same connection s" +
                         "tring.");
@@ -2375,4 +3904,13 @@
                 // ---- Prepare for update -----------
                 //
+                if ((this._resourceTableAdapter != null)) {
+                    revertConnections.Add(this._resourceTableAdapter, this._resourceTableAdapter.Connection);
+                    this._resourceTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(workConnection));
+                    this._resourceTableAdapter.Transaction = ((global::System.Data.SqlClient.SqlTransaction)(workTransaction));
+                    if (this._resourceTableAdapter.Adapter.AcceptChangesDuringUpdate) {
+                        this._resourceTableAdapter.Adapter.AcceptChangesDuringUpdate = false;
+                        adaptersWithAcceptChangesDuringUpdate.Add(this._resourceTableAdapter.Adapter);
+                    }
+                }
                 if ((this._clientTableAdapter != null)) {
                     revertConnections.Add(this._clientTableAdapter, this._clientTableAdapter.Connection);
@@ -2384,11 +3922,20 @@
                     }
                 }
-                if ((this._resourceTableAdapter != null)) {
-                    revertConnections.Add(this._resourceTableAdapter, this._resourceTableAdapter.Connection);
-                    this._resourceTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(workConnection));
-                    this._resourceTableAdapter.Transaction = ((global::System.Data.SqlClient.SqlTransaction)(workTransaction));
-                    if (this._resourceTableAdapter.Adapter.AcceptChangesDuringUpdate) {
-                        this._resourceTableAdapter.Adapter.AcceptChangesDuringUpdate = false;
-                        adaptersWithAcceptChangesDuringUpdate.Add(this._resourceTableAdapter.Adapter);
+                if ((this._hiveUserTableAdapter != null)) {
+                    revertConnections.Add(this._hiveUserTableAdapter, this._hiveUserTableAdapter.Connection);
+                    this._hiveUserTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(workConnection));
+                    this._hiveUserTableAdapter.Transaction = ((global::System.Data.SqlClient.SqlTransaction)(workTransaction));
+                    if (this._hiveUserTableAdapter.Adapter.AcceptChangesDuringUpdate) {
+                        this._hiveUserTableAdapter.Adapter.AcceptChangesDuringUpdate = false;
+                        adaptersWithAcceptChangesDuringUpdate.Add(this._hiveUserTableAdapter.Adapter);
+                    }
+                }
+                if ((this._permissionOwnerTableAdapter != null)) {
+                    revertConnections.Add(this._permissionOwnerTableAdapter, this._permissionOwnerTableAdapter.Connection);
+                    this._permissionOwnerTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(workConnection));
+                    this._permissionOwnerTableAdapter.Transaction = ((global::System.Data.SqlClient.SqlTransaction)(workTransaction));
+                    if (this._permissionOwnerTableAdapter.Adapter.AcceptChangesDuringUpdate) {
+                        this._permissionOwnerTableAdapter.Adapter.AcceptChangesDuringUpdate = false;
+                        adaptersWithAcceptChangesDuringUpdate.Add(this._permissionOwnerTableAdapter.Adapter);
                     }
                 }
@@ -2451,11 +3998,19 @@
                     workConnection.Close();
                 }
+                if ((this._resourceTableAdapter != null)) {
+                    this._resourceTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(revertConnections[this._resourceTableAdapter]));
+                    this._resourceTableAdapter.Transaction = null;
+                }
                 if ((this._clientTableAdapter != null)) {
                     this._clientTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(revertConnections[this._clientTableAdapter]));
                     this._clientTableAdapter.Transaction = null;
                 }
-                if ((this._resourceTableAdapter != null)) {
-                    this._resourceTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(revertConnections[this._resourceTableAdapter]));
-                    this._resourceTableAdapter.Transaction = null;
+                if ((this._hiveUserTableAdapter != null)) {
+                    this._hiveUserTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(revertConnections[this._hiveUserTableAdapter]));
+                    this._hiveUserTableAdapter.Transaction = null;
+                }
+                if ((this._permissionOwnerTableAdapter != null)) {
+                    this._permissionOwnerTableAdapter.Connection = ((global::System.Data.SqlClient.SqlConnection)(revertConnections[this._permissionOwnerTableAdapter]));
+                    this._permissionOwnerTableAdapter.Transaction = null;
                 }
                 if ((0 < adaptersWithAcceptChangesDuringUpdate.Count)) {
Index: trunk/sources/HeuristicLab.Hive.Server.Core/DbTestApp.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/DbTestApp.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/DbTestApp.cs	(revision 845)
@@ -41,4 +41,5 @@
 
       ClientInfo client = new ClientInfo();
+      client.Login = DateTime.Now;
       client.ClientId = Guid.NewGuid();
       clientAdapter.UpdateClient(client); 
Index: trunk/sources/HeuristicLab.Hive.Server.Core/HeuristicLab.Hive.Server.Core.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/HeuristicLab.Hive.Server.Core.csproj	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/HeuristicLab.Hive.Server.Core.csproj	(revision 845)
@@ -60,5 +60,7 @@
     </Compile>
     <Compile Include="InternalInterfaces\DataAccess\IClientAdapter.cs" />
+    <Compile Include="InternalInterfaces\DataAccess\IPermissionOwnerAdapter.cs" />
     <Compile Include="InternalInterfaces\DataAccess\IResourceAdapter.cs" />
+    <Compile Include="InternalInterfaces\DataAccess\IUserAdapter.cs" />
     <Compile Include="JobManager.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IPermissionOwnerAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IPermissionOwnerAdapter.cs	(revision 845)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IPermissionOwnerAdapter.cs	(revision 845)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess {
+  /// <summary>
+  /// The permission owner database adapter
+  /// </summary>
+  public interface IPermissionOwner {
+    /// <summary>
+    /// Save or update the permission owner
+    /// </summary>
+    /// <param name="client"></param>
+    void UpdatePermissionOwner(PermissionOwner permOwner);
+
+    /// <summary>
+    /// Get the permission owner with the specified ID
+    /// </summary>
+    /// <param name="clientId"></param>
+    /// <returns></returns>
+    PermissionOwner GetPermissionOwnerById(long resourceId);
+
+    /// <summary>
+    /// Get all permission owners
+    /// </summary>
+    /// <returns></returns>
+    ICollection<PermissionOwner> GetAllPermissionOwners();
+
+    /// <summary>
+    /// Deletes the permission owner
+    /// </summary>
+    /// <param name="permOwner"></param>
+    bool DeletePermissionOwner(PermissionOwner permOwner);
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IResourceAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IResourceAdapter.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IResourceAdapter.cs	(revision 845)
@@ -42,5 +42,5 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    ClientInfo GetResourceById(long resourceId);
+    Resource GetResourceById(long resourceId);
 
     /// <summary>
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserAdapter.cs	(revision 845)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserAdapter.cs	(revision 845)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess {
+  /// <summary>
+  /// The user database adapter
+  /// </summary>
+  public interface IUserAdapter {
+    /// <summary>
+    /// Save or update the user
+    /// </summary>
+    /// <param name="user"></param>
+    void UpdateUser(User user);
+
+    /// <summary>
+    /// Get the user with the specified ID
+    /// </summary>
+    /// <param name="userId"></param>
+    /// <returns></returns>
+    ClientInfo GetUserById(long userId);
+
+    /// <summary>
+    /// Get all users
+    /// </summary>
+    /// <returns></returns>
+    ICollection<User> GetAllUsers();
+
+    /// <summary>
+    /// Deletes the user
+    /// </summary>
+    /// <param name="user"></param>
+    bool DeleteUser(User user);
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/UserRoleManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/UserRoleManager.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/UserRoleManager.cs	(revision 845)
@@ -16,7 +16,7 @@
       userGroups = new List<UserGroup>();
 
-      users.Add(new User { UserId = 1, Name = "Hugo", Password = "hUg0" });
-      users.Add(new User { UserId = 2, Name = "Seppl", Password = "seppl" });
-      users.Add(new User { UserId = 3, Name = "Greg", Password = "greg" });
+      users.Add(new User { PermissionOwnerId = 1, Name = "Hugo", Password = "hUg0" });
+      users.Add(new User { PermissionOwnerId = 2, Name = "Seppl", Password = "seppl" });
+      users.Add(new User { PermissionOwnerId = 3, Name = "Greg", Password = "greg" });
 
       userGroups.Add(new UserGroup { UserGroupId = 1 });
